<template>
  <div class="row">
    <div class="col-12">
      <table class="table table-striped" v-if="cuposStore.cupos.length > 0">
        <thead>
          <tr class="bg-princial text-light fs-4 text-uppercase">
            <!--<th scope="col" style="padding: 15px 10px !important">Solicitante</th>-->
            <th scope="col" style="padding: 15px 10px !important">Fecha</th>
            <th scope="col" style="padding: 15px 10px !important">Cupo +- Transferencias</th>
            <th scope="col" style="padding: 15px 10px !important">Gastado</th>
            <th scope="col" style="padding: 15px 10px !important">Liquidado</th>
            <th scope="col" style="padding: 15px 10px !important">Disponible</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="cupo in cuposStore.cupos" :key="cupo.id_resumen_solicitante">
            <!--<td class="pt-2 pb-1 px-2 ps-3" v-text="aynMostrar(cupo)"></td>-->
            <td class="pt-2 pb-1 px-2 text-left" v-text="fechaMostrar(cupo.fecha_cupo)"></td>
            <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(cupo.monto_otorgado)"></td>
            <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(cupo.monto_gastado)"></td>
            <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(cupo.monto_liquidado)"></td>
            <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(cupo.monto_disponible)"></td>
          </tr>
        </tbody>
        <h6 class="text-black fs-4 text-uppercase" scope="col" style="padding: 15px 10px !important">TOTALES:</h6>
        <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(totales.total_otorgado)"></td>
        <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(totales.total_gastado)"></td>
        <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(totales.total_liquidado)"></td>
        <td class="pt-2 pb-1 px-2 text-left" v-text="importeMostrar(totales.total_disponible)"></td>
      </table>
      <div v-else class="alert alert-secondary text-center" role="alert">
        No se ha encontrado ning&uacute;n cupo en el sistema.
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { onMounted, reactive } from "vue";
import type { PropType } from "vue";
import { DateTime } from "luxon";
import { loading } from "@/shared.js";
// Entidades
//import type Cupo from "@/entities/becas/Cupo";
// Stores
import { useCuposStore } from "@/stores/becas/cupos";

//const aynMostrar = (cupo: Cupo) => cupo.apellido + ' ' + cupo.nombres;
const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const importeMostrar = (importe: number) => Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe);

const cuposStore = useCuposStore();

const props = defineProps({
  parametros: {
    type: Object as PropType<Object>,
    default: {},
    required: true,
  },
});

var totales = reactive({

  total_otorgado: 0 as number,
  total_gastado: 0 as number,
  total_liquidado: 0 as number,
  total_disponible: 0 as number,

});

onMounted(async () => {
  loading.show();
  await cuposStore.fetchCupos(props.parametros);
  calcularTotales();
  loading.hide();
})


function calcularTotales() {
  var cupos = cuposStore.cupos;
  cupos.forEach(element => {
    totales.total_otorgado += element.monto_otorgado;
    totales.total_gastado += element.monto_gastado;
    totales.total_liquidado += element.monto_liquidado;
    totales.total_disponible += element.monto_disponible;
  });
}
</script>
